import type { RefTyped } from '../types/global';
import type { Target } from '../libs/dom';
declare type EventType = MouseEvent | TouchEvent;
/**
 * useClickAway function
 *
 * @param target Execution handler target.
 * @param eventHandler Handler function on external click.
 * @param eventName Event trigger.
 */
declare function useClickAway(
  target: Target | Target[],
  eventHandler: RefTyped<(event: EventType) => void>,
  eventName?: RefTyped<string | string[]>,
): void;
export default useClickAway;
