import { ref, getCurrentInstance } from 'vue-demi';
import useEventListener from './useEventListener';
import { isServer } from '../libs/helper';
export default function useClipboard() {
  if (!getCurrentInstance()) {
    throw new Error(
      'Invalid hook call: `useClipboard` can only be called inside of `setup()`.',
    );
  }
  const text = ref('');
  const supported = !isServer && 'clipboard' in window.navigator;
  const getClipboardText = async () => {
    if (!isServer) {
      text.value = await window.navigator.clipboard.readText();
    }
  };
  getClipboardText();
  useEventListener('focus', getClipboardText);
  useEventListener('copy', getClipboardText);
  const copy = $text => {
    var _a, _b, _c;
    text.value = $text;
    return isServer
      ? new Promise(() => {})
      : (_c =
          (_b =
            (_a =
              window === null || window === void 0
                ? void 0
                : window.navigator) === null || _a === void 0
              ? void 0
              : _a.clipboard) === null || _b === void 0
            ? void 0
            : _b.writeText) === null || _c === void 0
      ? void 0
      : _c.call(_b, $text);
  };
  return { copy, text, supported };
}
