import type { Ref } from 'vue-demi';
import type { RefTyped } from '../types/global';
declare type NumberType = number | string;
export declare type CounterNumber = RefTyped<NumberType>;
declare type UseCounterActions = {
  inc: (n?: CounterNumber) => void;
  dec: (n?: CounterNumber) => void;
  set: (value: CounterNumber | ((currentValue: number) => number)) => void;
  reset: () => void;
};
declare type UseCounterReturnType = {
  count: Ref<number>;
} & UseCounterActions;
interface CounterOptions {
  min?: CounterNumber;
  max?: CounterNumber;
  step?: CounterNumber;
}
declare function useCounter(
  initialValue?: RefTyped<NumberType>,
  options?: CounterOptions,
): UseCounterReturnType;
export default useCounter;
