import type { Ref } from 'vue-demi';
import type { CounterNumber } from '../hooks/useCounter';
import type { RefTyped } from '../types/global';
interface UseCounterIntervalOptions {
  initialValue?: CounterNumber;
  type?: RefTyped<'inc' | 'dec'>;
  step?: RefTyped<number>;
  total?: RefTyped<number>;
  interval?: RefTyped<number>;
  immediateStart?: RefTyped<boolean>;
}
declare type UseCounterIntervalActions = {
  start: () => void;
  stop: () => void;
};
declare type UseCounterIntervalReturnType = {
  count: CounterNumber;
  isActive: Ref<boolean>;
} & UseCounterIntervalActions;
export default function useCounterInterval(
  options?: UseCounterIntervalOptions,
): UseCounterIntervalReturnType;
export {};
