import type { WatchSource, WatchCallback } from 'vue-demi';
import type { RefTyped } from '../types/global';
declare type MapSources<T> = {
  [K in keyof T]: T[K] extends WatchSource<infer V>
    ? V
    : T[K] extends object
    ? T[K]
    : never;
};
declare function useDebounceEffect<
  T extends Readonly<Array<WatchSource<unknown> | object>>
>(
  listener: WatchCallback<MapSources<T>, MapSources<T>>,
  deps: T,
  wait?: RefTyped<number>,
): any;
declare function useDebounceEffect<T>(
  listener: WatchCallback<T, T>,
  deps: WatchSource<T>,
  wait?: RefTyped<number>,
): any;
declare function useDebounceEffect<T extends object>(
  listener: WatchCallback<T, T>,
  deps: T,
  wait?: RefTyped<number>,
): any;
export default useDebounceEffect;
