import { unref, watch, getCurrentInstance } from 'vue-demi';
import useDebounceFn from './useDebounceFn';
function useDebounceEffect(listener, deps, wait = 0) {
  if (!getCurrentInstance()) {
    throw new Error(
      'Invalid hook call: `useDebounceEffect` can only be called inside of `setup()`.',
    );
  }
  const debounced = useDebounceFn(listener, wait);
  watch(deps, (value, oldValue) =>
    unref(wait) > 0
      ? debounced.value(value, oldValue)
      : listener(value, oldValue),
  );
}
export default useDebounceEffect;
