import type { Fn } from '../libs/debounce';
import type { RefTyped } from '../types/global';
/**
 * useDebounceFn function
 * @param callback The function or a promise to debounce.
 * @param wait The number of milliseconds to delay.
 *
 * @returns debounced ref function
 * @returns debounced.value.cancel function
 * @returns debounced.value.flush function
 */
declare function useDebounceFn<T extends Fn>(
  callback: T,
  wait?: RefTyped<number>,
): any;
export default useDebounceFn;
