import type { Ref } from 'vue-demi';
export interface UseDynamicListActions<S> {
  move(to: number, from: number): any;
  insert(idx: number, val: S): any;
  insertBefore(idx: number, val: S): any;
  insertAfter(idx: number, val: S): any;
  getKey(idx: number): any;
  deleteByIdx(idx: number): any;
  replace(to: number, from: number): any;
  unshift(...items: S[]): any;
  shift(): any;
  pop(): any;
  push(val: S): any;
}
export declare type UseDynamicListReturnType<T, S> = {
  list: Ref<T>;
} & UseDynamicListActions<S>;
export default function useDynamicList<T extends Array<unknown>, S = T[number]>(
  initValue?: T | undefined[],
): UseDynamicListReturnType<T, S>;
