import { ref } from 'vue-demi';
import { isArray } from '../libs/helper';
// TODO: ...
// export interface UseDynamicListOptions {
//   sort();
//   builder(fn: Function | object, times: number);
// }
// TODO: COMMENT NEED
export default function useDynamicList(initValue = []) {
  if (isArray(initValue) === false) {
    throw new Error('initValue should be a array');
  }
  const list = ref(initValue);
  const actions = {
    move(to, from) {
      list.value.splice(to, 0, list.value.splice(from, 1)[0]);
    },
    insert(idx, val) {
      list.value.splice(idx, 0, val);
    },
    insertBefore(idx, val) {
      list.value.splice(idx, -1, val);
    },
    insertAfter(idx, val) {
      list.value.splice(idx + 1, 0, val);
    },
    // TODO: ...
    getKey(idx) {},
    deleteByIdx(idx) {
      list.value.splice(idx, 1);
    },
    replace(to, from) {
      actions.move(to, from);
    },
    unshift(...items) {
      list.value.unshift(...items);
    },
    shift() {
      list.value.shift();
    },
    pop() {
      list.value.pop();
    },
    push(val) {
      list.value.push(val);
    },
  };
  return Object.assign({ list }, actions);
}
