import { reactive, readonly, toRefs, getCurrentInstance } from 'vue-demi';
import useEventListener from './useEventListener';
import { isServer } from '../libs/helper';
const initialState = {
  pageX: 0,
  pageY: 0,
  screenX: 0,
  screenY: 0,
  clientX: 0,
  clientY: 0,
};
// TODO: COMMENT NEED
export default function useMouse() {
  if (!getCurrentInstance()) {
    throw new Error(
      'Invalid hook call: `useMouse` can only be called inside of `setup()`.',
    );
  }
  const state = reactive(initialState);
  const moveHandler = event => {
    const { pageX, pageY, screenX, screenY, clientX, clientY } = event;
    state.pageX = pageX;
    state.pageY = pageY;
    state.screenX = screenX;
    state.screenY = screenY;
    state.clientX = clientX;
    state.clientY = clientY;
  };
  if (!isServer) {
    useEventListener(document, 'mousemove', moveHandler);
  }
  return toRefs(readonly(state));
}
