import { ref } from 'vue-demi';
const useQueue = (initialValue = []) => {
  const state = ref(Array.from(initialValue));
  return {
    add: value => state.value.push(value),
    remove: () => state.value.shift(),
    empty: () => {
      state.value = [];
    },
    reset: () => {
      state.value = Array.from(initialValue);
    },
    get first() {
      return state.value[0];
    },
    get last() {
      return state.value[state.value.length - 1];
    },
    get size() {
      return state.value.length;
    },
  };
};
export default useQueue;
