import { reactive, readonly, toRefs, getCurrentInstance } from 'vue-demi';
import useEventListener from './useEventListener';
import { getTargetElement } from '../libs/dom';
const initialState = {
  x: 0,
  y: 0,
};
// TODO: COMMENT NEED
export default function useScroll(target) {
  if (!getCurrentInstance()) {
    throw new Error(
      'Invalid hook call: `useScroll` can only be called inside of `setup()`.',
    );
  }
  const state = reactive(initialState);
  const scrollHandler = event => {
    const currentTarget = event.target;
    if (currentTarget === document) {
      state.x =
        document === null || document === void 0
          ? void 0
          : document.scrollingElement.scrollLeft;
      state.y =
        document === null || document === void 0
          ? void 0
          : document.scrollingElement.scrollTop;
    } else {
      state.x = currentTarget.scrollLeft;
      state.y = currentTarget.scrollTop;
    }
  };
  useEventListener(
    () => getTargetElement(target, document),
    'scroll',
    scrollHandler,
    {
      passive: true,
    },
  );
  return toRefs(readonly(state));
}
