import { getCurrentInstance } from 'vue-demi';
import useStorage from './useStorage';
const useSessionStorage = (key, defaultValue) => {
  if (getCurrentInstance()) {
    return useStorage(
      key,
      defaultValue,
      window === null || window === void 0 ? void 0 : window.sessionStorage,
    );
  } else {
    throw new Error(
      'Invalid hook call: `useSessionStorage` can only be called inside of `setup()`.',
    );
  }
};
export default useSessionStorage;
