import type { DeepReadonly, Ref } from 'vue-demi';
import type { RefTyped } from '../types/global';
interface SetActions<K> {
  add: (key: K) => void;
  remove: (key: K) => void;
  has: (key: K) => boolean;
  reset: () => void;
  clear: () => void;
}
declare type UseSetReturnType<K> = {
  set: DeepReadonly<Ref<Set<K>>>;
} & SetActions<K>;
declare const useSet: <K = any>(
  initialSet?: RefTyped<Iterable<K>>,
) => UseSetReturnType<K>;
export default useSet;
