import { readonly, ref, unref, getCurrentInstance } from 'vue-demi';
// TODO: COMMENT NEED
const useSet = initialSet => {
  if (!getCurrentInstance()) {
    throw new Error(
      'Invalid hook call: `useSet` can only be called inside of `setup()`.',
    );
  }
  const set = ref(new Set(unref(initialSet)));
  const actions = {
    add: item => {
      set.value.add(item);
    },
    remove: item => {
      set.value.delete(item);
    },
    has: item => set.value.has(item),
    reset: () => {
      set.value = new Set(unref(initialSet));
    },
    clear: () => {
      set.value.clear();
    },
  };
  return Object.assign({ set: readonly(set) }, actions);
};
export default useSet;
