import { ref, unref, readonly, watch, getCurrentInstance } from 'vue-demi';
import useThrottleFn from '../hooks/useThrottleFn';
// TODO: COMMENT NEED
export default function useThrottle(value, wait = 0) {
  if (!getCurrentInstance()) {
    throw new Error(
      'Invalid hook call: `useThrottle` can only be called inside of `setup()`.',
    );
  }
  const throttledValue = ref(unref(value));
  const throttled = useThrottleFn(
    () => (throttledValue.value = unref(value)),
    wait,
  );
  watch(value, () =>
    unref(wait) > 0 ? throttled.value() : (throttledValue.value = unref(value)),
  );
  return readonly(throttledValue);
}
