import { unref, watch, getCurrentInstance } from 'vue-demi';
import useThrottleFn from './useThrottleFn';
function useThrottleEffect(listener, deps, wait = 0) {
  if (!getCurrentInstance()) {
    throw new Error(
      'Invalid hook call: `useThrottleEffect` can only be called inside of `setup()`.',
    );
  }
  const throttled = useThrottleFn(listener, wait);
  watch(deps, (value, oldValue) =>
    unref(wait) > 0
      ? throttled.value(value, oldValue)
      : listener(value, oldValue),
  );
}
export default useThrottleEffect;
