import type { Fn } from '../libs/throttle';
import type { RefTyped } from '../types/global';
/**
 * useThrottleFn function
 * @param callback The function or a promise to debounce.
 * @param wait The number of milliseconds to delay.
 *
 * @returns throttled function
 * @returns throttled.cancel function
 * @returns throttled.flush function
 */
declare function useThrottleFn<T extends Fn>(
  callback: T,
  wait?: RefTyped<number>,
): any;
export default useThrottleFn;
