import type { RefTyped } from '../types/global';
/**
 * set the string to the page title.
 *
 * @param overridedTitle The string to set to the page title.
 * @param restoreOnUnmount whether need restore the title on unmount.
 */
declare function useTitle(
  overridedTitle?: RefTyped<string>,
  restoreOnUnmount?: RefTyped<boolean>,
): {
  title: import('vue-demi').Ref<string>;
  restoreTitle: () => void;
};
export default useTitle;
