import type { UnwrapRef, Ref } from 'vue-demi';
import type { RefTyped } from '../types/global';
declare type UseToggleState = string | number | boolean | null | undefined;
interface UseToggleActions {
  setLeft: () => void;
  setRight: () => void;
  toggle: (value?: any) => void;
}
declare type UseToggleReturnType<D, R> = {
  state: Ref<UnwrapRef<D> | UnwrapRef<R>>;
} & UseToggleActions;
/**
 * useToggle function
 *
 * @param defaultValue Truth value, default is `true`  - an optional parameter
 * @param reverseValue False value, default is `false` - an optional parameter
 * @returns [ status, { toggle, setLeft, setRight } ]
 */
declare function useToggle<
  D extends RefTyped<UseToggleState>,
  R extends RefTyped<UseToggleState>
>(defaultValue?: D, reverseValue?: R): UseToggleReturnType<D, R>;
export default useToggle;
