/* istanbul ignore file */
import { isRef, unref } from 'vue-demi';
import { isFunction } from './helper';
export function isHTMLElement(element) {
  return (
    (element === null || element === void 0 ? void 0 : element.nodeType) === 1
  );
}
export function getTargetElement(target, defaultElement) {
  if (!target) return defaultElement;
  const targetElement = isFunction(target)
    ? target()
    : isRef(target)
    ? unref(target)
    : target;
  return targetElement;
}
