export default class Emitter {
  constructor() {
    this.events = Object.create(null);
  }
  on(type, handler) {
    (this.events[type] || (this.events[type] = [])).push(handler);
  }
  off(type, handler) {
    this.events[type] &&
      this.events[type].splice(this.events[type].indexOf(handler) >>> 0, 1);
  }
  emit(type, ...args) {
    var _a;
    (_a = this.events[type]) === null || _a === void 0
      ? void 0
      : _a.forEach(handler => handler(args));
  }
}
