declare const eventsMap: {
  readonly change: 'fullscreenchange';
  readonly error: 'fullscreenerror';
};
export declare const request: (element?: HTMLElement) => void;
export declare const exit: (element?: HTMLElement) => void;
export declare const toggle: (element?: HTMLElement) => void;
export declare const on: (
  event: keyof typeof eventsMap,
  fn: () => void,
) => void;
export declare const off: (
  event: keyof typeof eventsMap,
  fn: () => void,
) => void;
declare const _default: {
  getFullscreenElement: () => Element;
  request: (element?: HTMLElement) => void;
  exit: (element?: HTMLElement) => void;
  toggle: (element?: HTMLElement) => void;
  on: (event: 'change' | 'error', fn: () => void) => void;
  off: (event: 'change' | 'error', fn: () => void) => void;
};
export default _default;
